diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 47e9020632c..1c095b27c6c 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -606,50 +606,21 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYDEV;
 }
 
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
+static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
 {
     unsigned short index;
-    int unicode;
 
-    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
     find_joydevs();
-    *pdev = NULL;
+    *out = NULL;
 
-    if ((index = get_joystick_index(rguid)) < MAX_JOYDEV &&
+    if ((index = get_joystick_index(guid)) < MAX_JOYDEV &&
         have_joydevs && index < have_joydevs)
     {
-        JoystickImpl *This;
-
-        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8A, riid))
-        {
-            unicode = 0;
-        }
-        else if (IsEqualGUID(&IID_IDirectInputDeviceW,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8W, riid))
-        {
-            unicode = 1;
-        }
-        else
-        {
-            WARN("no interface\n");
-            return DIERR_NOINTERFACE;
-        }
-
-        This = alloc_device(rguid, dinput, index);
+        JoystickImpl *This = alloc_device(guid, dinput, index);
         TRACE("Created a Joystick device (%p)\n", This);
-
         if (!This) return DIERR_OUTOFMEMORY;
-
-        if (unicode)
-            *pdev = &This->generic.base.IDirectInputDevice8W_iface;
-        else
-            *pdev = &This->generic.base.IDirectInputDevice8A_iface;
-
+        *out = &This->generic.base;
         return DI_OK;
     }
 
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 61da492a071..347e76a7bc4 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1232,7 +1232,6 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
 
     if (TRACE_ON(dinput)) {
         TRACE("allocated device %p\n", newDevice);
-        _dump_DIDATAFORMAT(newDevice->generic.base.data_format.wine_df);
         _dump_DIDEVCAPS(&newDevice->generic.devcaps);
     }
 
@@ -1274,51 +1273,24 @@ static unsigned short get_joystick_index(REFGUID guid)
     return 0xffff;
 }
 
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
+static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
 {
     unsigned short index;
     int joystick_devices_count;
-    int unicode;
 
-    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
-    *pdev = NULL;
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
+    *out = NULL;
 
     if ((joystick_devices_count = find_joystick_devices()) == 0)
         return DIERR_DEVICENOTREG;
 
-    if ((index = get_joystick_index(rguid)) < 0xffff &&
+    if ((index = get_joystick_index(guid)) < 0xffff &&
         joystick_devices_count && index < joystick_devices_count)
     {
         JoystickImpl *This;
-        HRESULT hr;
-
-        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8A, riid))
-        {
-            unicode = 0;
-        }
-        else if (IsEqualGUID(&IID_IDirectInputDeviceW,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8W, riid))
-        {
-            unicode = 1;
-        }
-        else
-        {
-            WARN("no interface\n");
-            return DIERR_NOINTERFACE;
-        }
-
-        hr = alloc_device(rguid, dinput, &This, index);
+        HRESULT hr = alloc_device(guid, dinput, &This, index);
         if (!This) return hr;
-
-        if (unicode)
-            *pdev = &This->generic.base.IDirectInputDevice8W_iface;
-        else
-            *pdev = &This->generic.base.IDirectInputDevice8A_iface;
+        *out = &This->generic.base;
         return hr;
     }
 
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index 70223074e2e..ae4a675aec7 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -280,46 +280,17 @@ failed:
     return NULL;
 }
 
-static HRESULT keyboarddev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
+static HRESULT keyboarddev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
 {
-    int unicode;
-    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
-    *pdev = NULL;
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
+    *out = NULL;
 
-    if (IsEqualGUID(&GUID_SysKeyboard, rguid)) /* Wine Keyboard */
+    if (IsEqualGUID(&GUID_SysKeyboard, guid)) /* Wine Keyboard */
     {
-        SysKeyboardImpl *This;
-
-        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8A, riid))
-        {
-            unicode = 0;
-        }
-        else if (IsEqualGUID(&IID_IDirectInputDeviceW,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8W, riid))
-        {
-            unicode = 1;
-        }
-        else
-        {
-            WARN("no interface\n");
-            return DIERR_NOINTERFACE;
-        }
-
-        This = alloc_device(rguid, dinput);
+        SysKeyboardImpl *This = alloc_device(guid, dinput);
         TRACE("Created a Keyboard device (%p)\n", This);
-
         if (!This) return DIERR_OUTOFMEMORY;
-
-        if (unicode)
-            *pdev = &This->base.IDirectInputDevice8W_iface;
-        else
-            *pdev = &This->base.IDirectInputDevice8A_iface;
-
+        *out = &This->base;
         return DI_OK;
     }
 
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index f5a49f51a07..06255bdafe5 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -238,46 +238,17 @@ failed:
     return NULL;
 }
 
-static HRESULT mousedev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
+static HRESULT mousedev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
 {
-    int unicode;
-    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
-    *pdev = NULL;
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
+    *out = NULL;
 
-    if (IsEqualGUID(&GUID_SysMouse, rguid)) /* Wine Mouse */
+    if (IsEqualGUID(&GUID_SysMouse, guid)) /* Wine Mouse */
     {
-        SysMouseImpl *This;
-
-        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8A, riid))
-        {
-            unicode = 0;
-        }
-        else if (IsEqualGUID(&IID_IDirectInputDeviceW,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8W, riid))
-        {
-            unicode = 1;
-        }
-        else
-        {
-            WARN("no interface\n");
-            return DIERR_NOINTERFACE;
-        }
-
-        This = alloc_device(rguid, dinput);
+        SysMouseImpl *This = alloc_device(guid, dinput);
         TRACE("Created a Mouse device (%p)\n", This);
-
         if (!This) return DIERR_OUTOFMEMORY;
-
-        if (unicode)
-            *pdev = &This->base.IDirectInputDevice8W_iface;
-        else
-            *pdev = &This->base.IDirectInputDevice8A_iface;
-
+        *out = &This->base;
         return DI_OK;
     }
 
-- 
2.28.0

>From 48687a6e43b7703d76b2b7afb2385c86094b0895 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 06/39] dinput: Factor IDirectInput8A implementation.

As proxy around IDirectInput8W interfaces.
---
 dlls/dinput/ansi.c           | 215 ++++++++++++++++++++
 dlls/dinput/dinput_main.c    | 378 ++---------------------------------
 dlls/dinput/dinput_private.h |   5 +-
 3 files changed, 230 insertions(+), 368 deletions(-)

diff --git a/dlls/dinput/ansi.c b/dlls/dinput/ansi.c
index edfbfb878cd..c2bd088ae6a 100644
--- a/dlls/dinput/ansi.c
+++ b/dlls/dinput/ansi.c
@@ -44,6 +44,20 @@ static IDirectInputDevice8W *IDirectInputDevice8W_from_impl(IDirectInputDeviceIm
     return &This->IDirectInputDevice8W_iface;
 }
 
+static inline IDirectInputDevice8A *IDirectInputDevice8A_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
+{
+    if (!iface) return NULL;
+    return &CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface)->IDirectInputDevice8A_iface;
+}
+static IDirectInputImpl *impl_from_IDirectInput8A(IDirectInput8A *iface)
+{
+    return CONTAINING_RECORD(iface, IDirectInputImpl, IDirectInput8A_iface);
+}
+static IDirectInput8W *IDirectInput8W_from_impl(IDirectInputImpl *This)
+{
+    return &This->IDirectInput8W_iface;
+}
+
 static void dideviceobjectinstance_wtoa(const DIDEVICEOBJECTINSTANCEW *didoiw, DIDEVICEOBJECTINSTANCEA *didoia)
 {
     didoia->guidType = didoiw->guidType;
@@ -189,6 +203,38 @@ static void dideviceimageinfoheader_wtoa(const DIDEVICEIMAGEINFOHEADERW *didiihw
     didiiha->dwBufferUsed = didiihw->dwBufferUsed / sizeof(DIDEVICEIMAGEINFOW) * sizeof(DIDEVICEIMAGEINFOA);
 }
 
+static void diconfiguredevicesparams_atow(const DICONFIGUREDEVICESPARAMSA *dicdpa, DICONFIGUREDEVICESPARAMSW *dicdpw)
+{
+    const char *username;
+    WCHAR *usernamew;
+    DWORD i, lenw = 1, lena;
+    dicdpw->dwcUsers = dicdpa->dwcUsers;
+    if (!dicdpa->lptszUserNames) dicdpw->lptszUserNames = NULL;
+    else
+    {
+        username = dicdpa->lptszUserNames;
+        for (i = 0; i < dicdpw->dwcUsers; ++i)
+        {
+            if (!(lena = strlen(username))) break;
+            lenw += MultiByteToWideChar(CP_ACP, 0, username, -1, NULL, 0);
+            username += lena + 1;
+        }
+        dicdpw->lptszUserNames = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (lenw + 1) * sizeof(WCHAR));
+        username = dicdpa->lptszUserNames;
+        usernamew = dicdpw->lptszUserNames;
+        for (i = 0; i < dicdpw->dwcUsers; ++i)
+        {
+            if (!(lena = strlen(username))) break;
+            usernamew += MultiByteToWideChar(CP_ACP, 0, username, -1, usernamew, lenw - (usernamew - dicdpw->lptszUserNames));
+            username += lena + 1;
+        }
+    }
+    dicdpw->dwcFormats = dicdpa->dwcFormats;
+    dicdpw->hwnd = dicdpa->hwnd;
+    dicdpw->dics = dicdpa->dics;
+    dicdpw->lpUnkDDSTarget = dicdpa->lpUnkDDSTarget;
+}
+
 static HRESULT STDMETHODCALLTYPE direct_input_device_a_QueryInterface(IDirectInputDevice8A *iface, REFIID iid, void **out)
 {
     IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
@@ -560,3 +606,172 @@ const IDirectInputDevice8AVtbl direct_input_device_a_vtbl =
     direct_input_device_a_SetActionMap,
     direct_input_device_a_GetImageInfo
 };
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_QueryInterface(IDirectInput8A *iface, REFIID iid, void **out)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    TRACE("iface %p, iid %s, out %p.\n", iface, debugstr_guid(iid), out);
+    return IDirectInput8_QueryInterface(IDirectInput8W_from_impl(This), iid, out);
+}
+
+static ULONG STDMETHODCALLTYPE direct_input_8_a_AddRef(IDirectInput8A *iface)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInput8_AddRef(IDirectInput8W_from_impl(This));
+}
+
+static ULONG STDMETHODCALLTYPE direct_input_8_a_Release(IDirectInput8A *iface)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInput8_Release(IDirectInput8W_from_impl(This));
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_CreateDevice(IDirectInput8A *iface, REFGUID guid,
+        IDirectInputDevice8A **out, IUnknown *outer)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    IDirectInputDevice8W *outw;
+    HRESULT hr;
+    TRACE("iface %p, guid %s, out %p, outer %p.\n", iface, debugstr_guid(guid), out, outer);
+    if (!out) return E_POINTER;
+    hr = IDirectInput8_CreateDevice(IDirectInput8W_from_impl(This), guid, &outw, outer);
+    *out = IDirectInputDevice8A_from_IDirectInputDevice8W(outw);
+    return hr;
+}
+
+struct direct_input_a_enum_devices_params
+{
+    LPDIENUMDEVICESCALLBACKA callback;
+    void *ref;
+};
+
+static BOOL CALLBACK direct_input_a_enum_devices_callback(const DIDEVICEINSTANCEW *didiw, void *data)
+{
+    struct direct_input_a_enum_devices_params *params = data;
+    DIDEVICEINSTANCEA didia = {sizeof(didia)};
+    dideviceinstance_wtoa(didiw, &didia);
+    return params->callback(&didia, params->ref);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_EnumDevices(IDirectInput8A *iface, DWORD type,
+        LPDIENUMDEVICESCALLBACKA callback, void *ref, DWORD flags)
+{
+    struct direct_input_a_enum_devices_params params = {callback, ref};
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    TRACE("iface %p, callback %p, ref %p, flags %#x.\n", iface, callback, ref, flags);
+    if (!callback) return DIERR_INVALIDPARAM;
+    return IDirectInput8_EnumDevices(IDirectInput8W_from_impl(This), type, direct_input_a_enum_devices_callback, &params, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_GetDeviceStatus(IDirectInput8A *iface, REFGUID instance_guid)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    TRACE("iface %p, instance_guid %s.\n", iface, debugstr_guid(instance_guid));
+    return IDirectInput8_GetDeviceStatus(IDirectInput8W_from_impl(This), instance_guid);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_RunControlPanel(IDirectInput8A *iface, HWND owner, DWORD flags)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    TRACE("iface %p, owner %p, flags %#x.\n", iface, owner, flags);
+    return IDirectInput8_RunControlPanel(IDirectInput8W_from_impl(This), owner, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_Initialize(IDirectInput8A *iface, HINSTANCE instance, DWORD version)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    TRACE("iface %p, instance %p, version %#x.\n", iface, instance, version);
+    return IDirectInput8_Initialize(IDirectInput8W_from_impl(This), instance, version);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_FindDevice(IDirectInput8A *iface, REFGUID guid, const char *name, GUID *instance_guid)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    WCHAR *namew = string_atow(name);
+    HRESULT hr;
+    TRACE("iface %p, guid %s, name %s, instance_guid %s.\n", iface, debugstr_guid(guid), debugstr_a(name),
+            debugstr_guid(instance_guid));
+    hr = IDirectInput8_FindDevice(IDirectInput8W_from_impl(This), guid, namew, instance_guid);
+    HeapFree(GetProcessHeap(), 0, namew);
+    return hr;
+}
+
+struct direct_input_a_enum_devices_by_semantics_params
+{
+    LPDIENUMDEVICESBYSEMANTICSCBA callback;
+    void *ref;
+};
+
+static BOOL CALLBACK direct_input_a_enum_devices_by_semantics_callback(const DIDEVICEINSTANCEW *didiw,
+        IDirectInputDevice8W *iface, DWORD flags, DWORD remaining, void *data)
+{
+    struct direct_input_a_enum_devices_by_semantics_params *params = data;
+    DIDEVICEINSTANCEA didia = {sizeof(didia)};
+    dideviceinstance_wtoa(didiw, &didia);
+    return params->callback(&didia, IDirectInputDevice8A_from_IDirectInputDevice8W(iface), flags, remaining, params->ref);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_EnumDevicesBySemantics(IDirectInput8A *iface, const char *username,
+        DIACTIONFORMATA *diaf, LPDIENUMDEVICESBYSEMANTICSCBA callback, void *ref, DWORD flags)
+{
+    struct direct_input_a_enum_devices_by_semantics_params params = {callback, ref};
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    DIACTIONFORMATW diafw = {sizeof(diafw), sizeof(DIACTIONW)};
+    WCHAR *usernamew = string_atow(username);
+    HRESULT hr;
+    TRACE("iface %p, username %s, diaf %p, callback %p, ref %p, flags %#x.\n", iface, debugstr_a(username), diaf,
+            callback, ref, flags);
+    if (!callback) return DIERR_INVALIDPARAM;
+    diafw.dwNumActions = diaf->dwNumActions;
+    diafw.rgoAction = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, diaf->dwNumActions * sizeof(DIACTIONW));
+    diactionformat_atow(diaf, &diafw);
+    hr = IDirectInput8_EnumDevicesBySemantics(IDirectInput8W_from_impl(This), usernamew, &diafw,
+            direct_input_a_enum_devices_by_semantics_callback, &params, flags);
+    HeapFree(GetProcessHeap(), 0, diafw.rgoAction);
+    HeapFree(GetProcessHeap(), 0, usernamew);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_8_a_ConfigureDevices(IDirectInput8A *iface,
+        LPDICONFIGUREDEVICESCALLBACK callback, DICONFIGUREDEVICESPARAMSA *dicdp, DWORD flags, void *ref)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
+    DICONFIGUREDEVICESPARAMSW dicdpw = {sizeof(dicdpw)};
+    DIACTIONFORMATW diafw = {sizeof(diafw), sizeof(DIACTIONW)};
+    DIACTIONFORMATA *diaf = dicdp->lprgFormats;
+    HRESULT hr;
+    DWORD i;
+    TRACE("iface %p, callback %p, dicdp %p, ref %p, flags %#x.\n", iface, callback, dicdp, ref, flags);
+    if (!callback) return DIERR_INVALIDPARAM;
+    diconfiguredevicesparams_atow(dicdp, &dicdpw);
+    diafw.dwNumActions = diaf->dwNumActions;
+    diafw.rgoAction = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, diaf->dwNumActions * sizeof(DIACTIONW));
+    diactionformat_atow(diaf, &diafw);
+    if (diafw.hInstString) for (i = 0; i < diafw.dwNumActions; ++i) diafw.rgoAction[i].uResIdString = diaf->rgoAction[i].uResIdString;
+    else for (i = 0; i < diafw.dwNumActions; ++i) diafw.rgoAction[i].lptszActionName = string_atow(diaf->rgoAction[i].lptszActionName);
+    dicdpw.lprgFormats = &diafw;
+    hr = IDirectInput8_ConfigureDevices(IDirectInput8W_from_impl(This), callback, &dicdpw, flags, ref);
+    if (!diafw.hInstString) for (i = 0; i < diafw.dwNumActions; ++i) HeapFree(GetProcessHeap(), 0, (void *)diafw.rgoAction[i].lptszActionName);
+    HeapFree(GetProcessHeap(), 0, diafw.rgoAction);
+    HeapFree(GetProcessHeap(), 0, dicdpw.lptszUserNames);
+    return hr;
+}
+
+const IDirectInput8AVtbl direct_input_8_a_vtbl =
+{
+    /*** IUnknown methods ***/
+    direct_input_8_a_QueryInterface,
+    direct_input_8_a_AddRef,
+    direct_input_8_a_Release,
+    /*** IDirectInput8A methods ***/
+    direct_input_8_a_CreateDevice,
+    direct_input_8_a_EnumDevices,
+    direct_input_8_a_GetDeviceStatus,
+    direct_input_8_a_RunControlPanel,
+    direct_input_8_a_Initialize,
+    direct_input_8_a_FindDevice,
+    direct_input_8_a_EnumDevicesBySemantics,
+    direct_input_8_a_ConfigureDevices,
+};
